/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
 *  Swtype.h								   *
 *  SQL Windows Type Definitions For DLL Interface			   *
 *  (c) 1990  Gupta Technologies, Inc.  All Rights Reserved.               *
\* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

#ifndef _INC_SWTYPE
#define _INC_SWTYPE

/***** All these must match SQLWIN:misc.h. *****/

#ifndef NUMBERSIZE

#define NUMBERSIZE   sizeof(NUMBER)		/* numeric buffer size */

/* NUMBER/DATETIME MUST MATCH SQLWIN's MISC.H */

typedef struct tagNUMBER
{
  BYTE numLength;
  BYTE numValue[12];
} NUMBER;
typedef NUMBER FAR *LPNUMBER;
typedef NUMBER     *PNUMBER;

#endif

/* SqlWin, DATETIME */

#define	DTLENGTHMASK	0x0F

typedef struct tagDATETIME {
    BYTE        DATETIME_Length;        /* length of date/time          */
    BYTE        DATETIME_Buffer[12];    /* SQLSDAT */
} DATETIME;
typedef DATETIME FAR*   LPDATETIME;
typedef DATETIME *      PDATETIME;

#define DTGETLENGTH(dt) ((dt)->DATETIME_Length & DTLENGTHMASK)

typedef signed	 char CHAR;
typedef unsigned char UCHAR;
typedef signed	 int  INT;
typedef unsigned int  UINT;
typedef unsigned long ULONG;

typedef VOID  FAR   * FARHANDLE;

typedef WORD    HOUTLINE;
typedef int     SQLCURSORNUMBER; 
typedef DWORD   HITEM;

typedef HANDLE        HARRAY;
typedef DWORD         TEMPLATE;
typedef ULONG	      HSTRING;
typedef WORD 	      HFFILE;
typedef int           SQLHANDLENUMBER;

typedef BOOL	    * PBOOL;
typedef HWND	    * PHWND;

typedef BOOL    FAR * LPBOOL;
typedef CHAR    FAR * LPCHAR;
typedef double  FAR * LPDOUBLE;
typedef float   FAR * LPFLOAT;
typedef HWND    FAR * LPHWND;
typedef ULONG   FAR * LPULONG;
typedef HFFILE   FAR * LPHFFILE;
typedef HSTRING FAR * LPHSTRING;
typedef SQLHANDLENUMBER FAR * LPSQLHANDLENUMBER;

typedef BOOL  NEAR  * NPBOOL;
typedef BYTE  NEAR  * NPBYTE;
typedef CHAR  NEAR  * NPCHAR;
typedef double NEAR * NPDOUBLE;
typedef DWORD NEAR  * NPDWORD;
typedef float NEAR  * NPFLOAT;
typedef INT   NEAR  * NPINT;
typedef LONG  NEAR  * NPLONG;
typedef VOID  NEAR  * NPVOID;
typedef WORD  NEAR  * NPWORD;

typedef LPSTR FAR   * LPLPSTR;

/* MUST MATCH SAL.H!!!! */

typedef BOOL (*LPPROCDDMWRITECALLBACK) ( WORD, LPLPSTR, DWORD );
typedef BOOL (*LPPROCDDMREADCALLBACK)   ( WORD, LPLPSTR, LPDWORD );
typedef BOOL (*LPPROCDDMDISCARDCALLBACK)( WORD );
typedef BOOL (*LPPROCDDMPREPARECALLBACK)( LPSTR, BOOL, LPWORD, LPWORD, 
  LPBOOL, LPINT, LPINT );

#endif /* _INC_SWTYPE */
